
<template>
    <el-container style="height: 100%">
        <el-header color="#333">
            <commonheader></commonheader>
        </el-header>
        <el-container>
            <el-aside width="auto">
                <commonaside></commonaside>
            </el-aside>
            <el-main>
              <div class="tabControl">
                  <el-tabs v-model="activeName" @tab-click="handleClick">
                    <el-tab-pane label="骑手审核" name="rider">
                        <el-table :data="riderList" style="width: 100%">
                          <el-table-column type="expand">
                            <template slot-scope="props">
                              <el-form label-position="left" inline class="demo-table-expand">
                                <el-form-item label="用户名称">
                                  <span>{{ props.row.userName }}</span>
                                </el-form-item>
                                <el-form-item label="用户昵称">
                                  <span>{{ props.row.userNickname ? props.row.userNickname : '未知' }}</span>
                                </el-form-item>
                                <el-form-item label="用户电话">
                                  <span>{{ props.row.userPhone ? props.row.userPhone : '未知' }}</span>
                                </el-form-item>
                                <el-form-item label="用户邮箱">
                                  <span>{{ props.row.userEmail ? props.row.userEmail : '未知' }}</span>
                                </el-form-item>
                                <el-form-item label="认证状态:">
                                  <span >{{StatusName[props.row.userIsRider]}}</span>
                                </el-form-item>
                                <el-form-item label="">
                                  <span></span>
                                </el-form-item>
                                <el-form-item label="驾驶证">
                                  <img :src="props.row.userDrivingLicense" style="height: 225px;">
                                </el-form-item>
                                <el-form-item label="健康证明">
                                  <img :src="props.row.userHealthCertificate" style="height: 225px;">
                                </el-form-item>
                                <el-form-item style="width: 100%; text-align:center;" v-if="props.row.userIsRider === 1 || props.row.userIsRider === 2">
                                  <el-button type="success" @click="UserVerify(0,props.row.userName,1)">通过</el-button>
                                  <el-button type="danger" @click="UserVerify(0,props.row.userName,0)">不通过</el-button>
                                </el-form-item>
                              </el-form>
                            </template>
                          </el-table-column>
                          <el-table-column
                            label="用户名"
                            prop="userName">
                          </el-table-column>
                          <el-table-column
                            label="联系方式"
                            prop="Connection">
                          </el-table-column>
                          <el-table-column
                            label="认证状态"
                            :filters="[{ text: '已认证', value: 1 }, {text: '待认证', value: 2}]"
                            :filter-method="filterHistoryTag"
                            filter-placement="bottom-end">
                            <template slot-scope="scope">
                              <el-tag
                                :type="scope.row.userIsRider === 0 || scope.row.userIsRider === 1 || scope.row.userIsRider === 3 ? 'danger':'success'"
                                disable-transitions>{{scope.row.userIsRider === 0 || scope.row.userIsRider === 1 || scope.row.userIsRider === 3 ? '待认证':'已认证'}}</el-tag>
                            </template>
                          </el-table-column>
                        <el-table-column
                          label="审核状态"
                          :filters="[{text: '未认证', value: 0 },{ text: '认证待审核', value: 1 }, {text: '修改待审核', value: 2}, {text: '认证不通过', value: 3}, {text: '修改不通过', value: 4}, {text: '审核通过', value: 5}]"
                          :filter-method="filterRecTag"
                          filter-placement="bottom-end">
                          <template slot-scope="scope">
                            <el-tag
                              :type="StatusType[scope.row.userIsRider]"
                              disable-transitions>{{StatusName[scope.row.userIsRider]}}</el-tag>
                          </template>
                        </el-table-column>
                        <el-table-column label="操作">
                          <template slot-scope="scope">
                            <el-button type="text" @click="UserVerify(0,scope.row.userName,1)" size="small" v-if="scope.row.userIsRider === 1 || scope.row.userIsRider === 2">通过</el-button>
                            <el-button type="text" @click="UserVerify(0,scope.row.userName,0)" size="small" v-if="scope.row.userIsRider === 1 || scope.row.userIsRider === 2">不通过</el-button>
                          </template>
                        </el-table-column>
                      </el-table>
                    </el-tab-pane>
                    <el-tab-pane label="食品商家审核" name="food">
                      <el-table :data="FoodList" style="width: 100%">
                          <el-table-column type="expand">
                            <template slot-scope="props">
                              <el-form label-position="left" inline class="demo-table-expand">
                                <el-form-item label="用户名称">
                                  <span>{{ props.row.userName }}</span>
                                </el-form-item>
                                <el-form-item label="用户昵称">
                                  <span>{{ props.row.userNickname ? props.row.userNickname : '未知' }}</span>
                                </el-form-item>
                                <el-form-item label="用户电话">
                                  <span>{{ props.row.userPhone ? props.row.userPhone : '未知' }}</span>
                                </el-form-item>
                                <el-form-item label="用户邮箱">
                                  <span>{{ props.row.userEmail ? props.row.userEmail : '未知' }}</span>
                                </el-form-item>
                                <el-form-item label="认证状态:">
                                  <span >{{StatusName[props.row.userIsFoodMerchant]}}</span>
                                </el-form-item>
                                <el-form-item label="">
                                  <span></span>
                                </el-form-item>
                                <el-form-item label="身份证">
                                  <img :src="props.row.userIdProof" style="height: 225px;">
                                </el-form-item>
                                <el-form-item label="营业执照">
                                  <img :src="props.row.userQualificationProof" style="height: 225px;">
                                </el-form-item>
                                <el-form-item style="width: 100%; text-align:center;" v-if="props.row.userIsFoodMerchant === 1 || props.row.userIsFoodMerchant === 2">
                                  <el-button type="success" @click="UserVerify(0,props.row.userName,1)">通过</el-button>
                                  <el-button type="danger" @click="UserVerify(0,props.row.userName,0)">不通过</el-button>
                                </el-form-item>
                              </el-form>
                            </template>
                          </el-table-column>
                          <el-table-column
                            label="用户名"
                            prop="userName">
                          </el-table-column>
                          <el-table-column
                            label="联系方式"
                            prop="Connection">
                          </el-table-column>
                          <el-table-column
                            label="认证状态"
                            :filters="[{ text: '已认证', value: 1 }, {text: '待认证', value: 2}]"
                            :filter-method="filterHistoryTag"
                            filter-placement="bottom-end">
                            <template slot-scope="scope">
                              <el-tag
                                :type="scope.row.userIsFoodMerchant === 0 || scope.row.userIsFoodMerchant === 1 || scope.row.userIsFoodMerchant === 3 ? 'danger':'success'"
                                disable-transitions>{{scope.row.userIsFoodMerchant === 0 || scope.row.userIsFoodMerchant === 1 || scope.row.userIsFoodMerchant === 3 ? '待认证':'已认证'}}</el-tag>
                            </template>
                          </el-table-column>
                        <el-table-column
                          label="审核状态"
                          :filters="[{text: '未认证', value: 0 },{ text: '认证待审核', value: 1 }, {text: '修改待审核', value: 2}, {text: '认证不通过', value: 3}, {text: '修改不通过', value: 4}, {text: '审核通过', value: 5}]"
                          :filter-method="filterRecTag"
                          filter-placement="bottom-end">
                          <template slot-scope="scope">
                            <el-tag
                              :type="StatusType[scope.row.userIsFoodMerchant]"
                              disable-transitions>{{StatusName[scope.row.userIsFoodMerchant]}}</el-tag>
                          </template>
                        </el-table-column>
                        <el-table-column label="操作">
                          <template slot-scope="scope">
                            <el-button type="text" @click="UserVerify(1,scope.row.userName,1)" size="small" v-if="scope.row.userIsFoodMerchant === 1 || scope.row.userIsFoodMerchant === 2">通过</el-button>
                            <el-button type="text" @click="UserVerify(1,scope.row.userName,0)" size="small" v-if="scope.row.userIsFoodMerchant === 1 || scope.row.userIsFoodMerchant === 2">不通过</el-button>
                          </template>
                        </el-table-column>
                      </el-table>
                    </el-tab-pane>
                    <el-tab-pane label="健身商家审核" name="service">
                      <el-table :data="GymList" style="width: 100%">
                          <el-table-column type="expand">
                            <template slot-scope="props">
                              <el-form label-position="left" inline class="demo-table-expand">
                                <el-form-item label="用户名称">
                                  <span>{{ props.row.userName }}</span>
                                </el-form-item>
                                <el-form-item label="用户昵称">
                                  <span>{{ props.row.userNickname ? props.row.userNickname : '未知' }}</span>
                                </el-form-item>
                                <el-form-item label="用户电话">
                                  <span>{{ props.row.userPhone ? props.row.userPhone : '未知' }}</span>
                                </el-form-item>
                                <el-form-item label="用户邮箱">
                                  <span>{{ props.row.userEmail ? props.row.userEmail : '未知' }}</span>
                                </el-form-item>
                                <el-form-item label="认证状态:">
                                  <span >{{StatusName[props.row.userIsGymMerchant]}}</span>
                                </el-form-item>
                                <el-form-item label="">
                                  <span></span>
                                </el-form-item>
                                <el-form-item label="身份证">
                                  <img :src="props.row.userIdProof" style="height: 225px;">
                                </el-form-item>
                                <el-form-item label="营业执照">
                                  <img :src="props.row.userQualificationProof" style="height: 225px;">
                                </el-form-item>
                                <el-form-item style="width: 100%; text-align:center;" v-if="props.row.userIsGymMerchant === 1 || props.row.userIsGymMerchant === 2">
                                  <el-button type="success" @click="UserVerify(2,props.row.userName,1)">通过</el-button>
                                  <el-button type="danger" @click="UserVerify(2,props.row.userName,0)">不通过</el-button>
                                </el-form-item>
                              </el-form>
                            </template>
                          </el-table-column>
                          <el-table-column
                            label="用户名"
                            prop="userName">
                          </el-table-column>
                          <el-table-column
                            label="联系方式"
                            prop="Connection">
                          </el-table-column>
                          <el-table-column
                            label="认证状态"
                            :filters="[{ text: '已认证', value: 1 }, {text: '待认证', value: 2}]"
                            :filter-method="filterHistoryTag"
                            filter-placement="bottom-end">
                            <template slot-scope="scope">
                              <el-tag
                                :type="scope.row.userIsGymMerchant === 0 || scope.row.userIsGymMerchant === 1 || scope.row.userIsGymMerchant === 3 ? 'danger':'success'"
                                disable-transitions>{{scope.row.userIsGymMerchant === 0 || scope.row.userIsGymMerchant === 1 || scope.row.userIsGymMerchant === 3 ? '待认证':'已认证'}}</el-tag>
                            </template>
                          </el-table-column>
                        <el-table-column
                          label="审核状态"
                          :filters="[{text: '未认证', value: 0 },{ text: '认证待审核', value: 1 }, {text: '修改待审核', value: 2}, {text: '认证不通过', value: 3}, {text: '修改不通过', value: 4}, {text: '审核通过', value: 5}]"
                          :filter-method="filterRecTag"
                          filter-placement="bottom-end">
                          <template slot-scope="scope">
                            <el-tag
                              :type="StatusType[scope.row.userIsGymMerchant]"
                              disable-transitions>{{StatusName[scope.row.userIsGymMerchant]}}</el-tag>
                          </template>
                        </el-table-column>
                        <el-table-column label="操作">
                          <template slot-scope="scope">
                            <el-button type="text" @click="UserVerify(2,scope.row.userName,1)" size="small" v-if="scope.row.userIsGymMerchant === 1 || scope.row.userIsGymMerchant === 2">通过</el-button>
                            <el-button type="text" @click="UserVerify(2,scope.row.userName,0)" size="small" v-if="scope.row.userIsGymMerchant === 1 || scope.row.userIsGymMerchant === 2">不通过</el-button>
                          </template>
                        </el-table-column>
                      </el-table>
                    </el-tab-pane>
                  </el-tabs>
              </div>
            </el-main>
        </el-container>
    </el-container>
</template>

<script>
import AdminRecognize from '@/services/AdminRecognize'
import commonaside from '../components/commonaside.vue'
import commonheader from '../components/commonheader.vue'

export default {
  components: {
    commonaside,
    commonheader
  },

  name: 'AdminRecognize',
  data () {
    return {
      activeName: 'rider',
      StatusType: [
        'info',
        'primary',
        'warning',
        'danger',
        'danger',
        'success'
      ],
      StatusName: [
        '未认证',
        '认证待审核',
        '修改待审核',
        '认证不通过',
        '修改不通过',
        '审核通过'
      ],
      riderList: [{
      }],
      FoodList: [{
      }],
      GymList: [{
      }],
      user: {
      }
    }
  },
  async created () {
    if (this.$store.state.token === '') {
      this.$router.go(-1)
      this.$message({
        showClose: true,
        message: '用户尚未登陆,无法访问审核界面,请先登陆……',
        type: 'error'
      })
    }
    await this.getRiderList()
    await this.getFoodList()
    await this.getGymList()
  },
  methods: {
    async getRiderList () {
      console.log('token')
      console.log(this.$store.state.token)
      try {
        const response = await AdminRecognize.getRiders({
          headers: {'Authorization': this.$store.state.token}
        })
        this.riderList = response.data.data.riders
        console.log(this.riderList)
        var i
        for (i in this.riderList) {
          this.riderList[i].Connection = this.riderList[i].userPhone ? this.riderList[i].userPhone : this.riderList[i].userEmail
        }
        console.log(this.riderList)
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          console.log(error)
          console.log('Network Error')
          this.error = 'Network Error'
        } else {
          this.$router.go(-1)
          this.$message({
            showClose: true,
            message: '用户无权访问审核页面',
            type: 'error'
          })

          this.error = error.response.data.error
          console.log(error.response.data.error)
        }
      }
    },
    async getFoodList () {
      try {
        const response = await AdminRecognize.getFoods({
          headers: {'Authorization': this.$store.state.token}
        })
        this.FoodList = response.data.data.foodMerchants
        var i
        for (i in this.FoodList) {
          this.FoodList[i].Connection = this.FoodList[i].userPhone ? this.FoodList[i].userPhone : this.FoodList[i].userEmail
        }
        console.log(this.FoodList)
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          console.log(error)
          console.log('Network Error')
          this.error = 'Network Error'
        } else {
          this.error = error.response.data.error
          console.log(error.response.data.error)
        }
      }
    },
    async getGymList () {
      try {
        const response = await AdminRecognize.getGyms({
          headers: {'Authorization': this.$store.state.token}
        })
        this.GymList = response.data.data.gymMerchants
        var i
        for (i in this.GymList) {
          this.GymList[i].Connection = this.GymList[i].userPhone ? this.GymList[i].userPhone : this.GymList[i].userEmail
        }
        console.log(this.GymList)
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          console.log(error)
          console.log('Network Error')
          this.error = 'Network Error'
        } else {
          this.error = error.response.data.error
          console.log(error.response.data.error)
        }
      }
    },
    handleClick (tab, event) {
      console.log(tab, event)
    },
    filterHistoryTag (value, row) {
      if (value === 2) {
        return row.userIsRider === 0 || row.userIsRider === 1 || row.userIsRider === 3
      } else {
        return row.userIsRider === 2 || row.userIsRider === 4 || row.userIsRider === 5
      }
    },
    filterRecTag (value, row) {
      return row.userIsRider === value
    },
    async UserVerify (type, userName, isVerify) {
      console.log('verify')
      console.log(userName + ':' + isVerify)
      try {
        let response
        if (type === 0) {
          response = await AdminRecognize.RiderVerify({
            userName: userName,
            isVerified: isVerify
          }, {
            headers: {'Authorization': this.$store.state.token}
          })
        } else if (type === 1) {
          response = await AdminRecognize.FoodVerify({
            userName: userName,
            isVerified: isVerify
          }, {
            headers: {'Authorization': this.$store.state.token}
          })
        } else {
          response = await AdminRecognize.GymVerify({
            userName: userName,
            isVerified: isVerify
          }, {
            headers: {'Authorization': this.$store.state.token}
          })
        }
        console.log(response.data.code, response.data.msg)
        if (response.data === undefined || response.data.code !== 200) {
          this.$message({
            showClose: true,
            message: response.data === undefined ? '网络错误,无法访问' : response.data.msg,
            type: 'error'
          })
        } else {
          this.$message({
            showClose: true,
            message: response.data.data,
            type: 'success'
          })
        }
      } catch (error) {
        this.$message({
          showClose: true,
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,无法访问' : error.response.data.msg,
          type: 'error'
        })
      }
      this.getRiderList()
      this.getFoodList()
      this.getGymList()
      this.$forceUpdate()
    }
  }
}

</script>

<style scoped>
  .demo-table-expand {
    font-size: 0;
  }
  .demo-table-expand label {
    width: 90px;
    color: #99a9bf;
  }
  .demo-table-expand .el-form-item {
    margin-right: 0;
    margin-bottom: 0;
    width: 50%;
  }
  .el-header {
      background-color: #333;
  }
  .el-main {
      padding-top: 0;
  }
</style>
